<?php

include('includes/global.php');

ShowPage();

function ShowTeamList()
{  
  global $Config, $Database;
  
  echo('<h3>Seznam překladatelských týmů</h3>');

  $DbResult = $Database->SQLCommand('SELECT COUNT(*) FROM `team`');
  $DbRow = mysql_fetch_row($DbResult);
  $PageList = GetPageList($DbRow[0]);    

  echo($PageList['Output']);
  echo('<table class="BaseTable">');

  $TableColumns = array(
    array('Name' => 'name', 'Title' => 'Jméno'), 
    array('Name' => 'numberuser', 'Title' => 'Počet členů'), 
  );
  if(Licence(LICENCE_USER)) $TableColumns[] = array('Name' => '', 'Title' => 'Uživatelské akce');

  $Order = GetOrderTableHeader($TableColumns, 'numberuser', 1);
  echo($Order['Output']);

  if(array_key_exists('search', $_GET))  $_SESSION['search'] = ' WHERE `name` LIKE "%'.$_GET['search'].'%" OR `description` LIKE "%'.$_GET['search'].'%"'; 
    else if(!array_key_exists('search', $_SESSION)) $_SESSION['search'] = '';
    if (array_key_exists('search', $_GET) and ($_GET['search'] == '')) $_SESSION['search'] = '';
    /*
    if(array_key_exists('team', $_GET))
    {
      $_SESSION['team'] = $_GET['team']; 
      if($_GET['team'] == '') $_SESSION['team'] = '';     
    } else if(!array_key_exists('team', $_SESSION)) $_SESSION['team'] = '';
    
    if(is_numeric($_SESSION['team'])) $Where = ' WHERE '.$_SESSION['team'];
      else $Where = '';

    if(!is_numeric($_SESSION['team'])) echo(' <a href="?Where">Zrušit filtr týmů</a><br />');
    */

    $ID = $Database->SQLCommand('SELECT *, (SELECT COUNT(*) FROM user WHERE user.team = team.ID) AS numberuser FROM team '.$_SESSION['search'].$Order['SQL'].$PageList['SQLLimit']);
    while($Line = mysql_fetch_assoc($ID)) 
    {
      echo('<tr>'.
        '<td><a href="?action=team&amp;id='.$Line['ID'].'">'.$Line['name'].'</a></td>'.
        '<td><a href="userlist.php?team='.$Line['ID'].'" title="Zobrazit členy týmu">'.$Line['numberuser'].'</a></td>');
      if(Licence(LICENCE_USER)) echo ('<td><a href="?action=gointeam&amp;id='.$Line['ID'].'">Vstoupit do týmu</a></td>');
    echo('</tr>');
    }
    echo('</table>');
    echo($PageList['Output']);
    
    if(Licence(LICENCE_USER)) echo('<br /><div style="text-align: center;"><a href="?action=create">Vytvořit překladatelský tým</a></div>');
}          

if(array_key_exists('action', $_GET))
{
  if($_GET['action'] == 'gointeam')
  {
    if(Licence(LICENCE_USER))
    {   
      if(array_key_exists('id', $_GET))
      { 
        $ID = $Database->SQLCommand('UPDATE user SET team = '.$_GET['id'].' WHERE ID = '.$_SESSION['UserID']); 
        echo('<strong>Vstoupil jsi do týmu</strong><br /><br />');    
        WriteLog('Uživatel vstoupil do týmu '.$_GET['id'], 3);

        // Delete all teams without users
        $Database->SQLCommand('DELETE FROM `team` WHERE (SELECT COUNT(*) FROM user WHERE user.team = team.ID) = 0');    
        
        ShowTeamList();
      } else echo('Nutno zadat id týmu');
    } else echo('Nemáte oprávnění');
  } else
  if($_GET['action'] == 'finish_create')
  {
    if(Licence(LICENCE_USER))
    {   
      if(array_key_exists('name', $_POST) and array_key_exists('description', $_POST))
      {
        $DbResult = $Database->SQLCommand('SELECT COUNT(*) FROM `team` WHERE `name` = "'.trim($_POST['name']).'"');  
        $DbRow = mysql_fetch_row($DbResult);
        $Count = $DbRow[0];
        if($Count == 0)
        {
          $ID = $Database->SQLCommand('INSERT INTO `team` (`name` ,`description` ) VALUES ( \''.trim($_POST['name']).'\', \''.trim($_POST['description']).'\');');  
          $Database->SQLCommand('UPDATE user SET team = '.mysql_insert_id().' WHERE ID = '.$_SESSION['UserID']); 
          echo('<strong>Překladatelský tým vytvořen</strong><br /><br />');
          WriteLog('Překladatelský tým vytvořen '.$_POST['name'], 3);

          // Delete all teams without users
          $Database->SQLCommand('DELETE FROM `team` WHERE (SELECT COUNT(*) FROM user WHERE user.team = team.ID) = 0');    
        } else echo('Již existuje tým se stejným jménem');
      } else echo('Chybí údaje formuláře');
    } else echo('Nemáte oprávnění');
    ShowTeamList();
  } else
  if($_GET['action'] == 'create')
  {
    if(Licence(LICENCE_USER))
    {   
      echo('<form action="?action=finish_create" method="post">'.
      '<fieldset><legend>Vytvoření nového týmu</legend>'.
      '<table><tr><td>Jméno:</td><td><input type="text" name="name" /></td></tr>'.
      '<tr><td>Popis:</td><td><input type="text" name="description" /></td></tr>'.
      '<tr><td colspan="2"><input type="submit" value="Vytvořit a vstoupit" /></td></tr>'.
      '</table></fieldset></form>');
    } else echo('Nemáte oprávnění');
  } else
  if($_GET['action'] == 'team') // Zobrazení týmu
  {
    if(array_key_exists('id', $_GET))
    { 
      include('img_level.php');
      $Columns = '';
      $Joins = '';
      foreach($TranslationTree as $Group)
      if($Group['TablePrefix'] != '')
      {
        $Columns .= 'COALESCE(T'.$Group['Id'].'.Count, 0) + ';
        $Joins .= ' LEFT JOIN (SELECT User, COUNT(User) as Count FROM `'.$Group['TablePrefix'].'` WHERE (Complete = 1) AND (Language <> 0) GROUP BY User) as T'.$Group['Id'].' ON user.ID=T'.$Group['Id'].'.User';
      }
      
      $Line = mysql_fetch_assoc($Database->SQLCommand('SELECT *,(SELECT count(*) FROM user WHERE team = team.ID) as numberuser, (SELECT sum('.substr($Columns, 0, -3).') FROM user '.$Joins.' WHERE team = team.ID) as NumberTranslate FROM team WHERE ID='.$_GET['id'])); 
    
     echo('<strong>Překladatelský tým '.$Line['name'].'</strong><br />'.
      $Line['description'].'<br /><br />'.
        '<a href="export/?team='.$_GET['id'].'">Exportovat překlad týmu</a> ');
      if(Licence(LICENCE_USER)) echo('<a href="?action=gointeam&amp;id='.$Line['ID'].'">Vstoupit do týmu</a><br /><br />');
      echo('<fieldset><legend>Statistika</legend>'.
      'Počet členů týmu: <a href="userlist.php?team='.$Line['ID'].'" title="Zobrazit členy týmu">'.$Line['numberuser'].'</a><br />'.
      'Počet přeložených textů týmu: <strong>'.$Line['NumberTranslate'].'</strong><br />'.
      'Průměrná úroveň překladatelů v týmu: <img src="tmp/team/'.$Line['name'].'/level.png" /><br /><br />'.
      '<strong>Stav dokončení pro tým:</strong><br />');
      foreach($TranslationTree as $Group)
        if($Group['TablePrefix'] != '') 
          echo('<div class="state-image"><img alt="'.$Group['TablePrefix'].'" src="img_statistic.php?group='.$Group['Id'].'&amp;team='.$_GET['id'].'" title="statistika překladů '.$Group['Name'].'"/></div>');
      echo('</fieldset>');    
    } else echo('Musíte zadat id týmu');
  } else ShowTeamList();
} else ShowTeamList();

ShowFooter();      

?>
